# Related Software

TopoStats is one of many pieces of software available for working with Atomic Force Microscopy data, other packages are
detailed here. If you know of another package please consider making a pull request to add it to the list.

## Python

* [afmformats](https://github.com/AFM-Analysis/afmformats) reading common AFM file formats.
* [gwyfile](https://pypi.org/project/gwyfile/) a pure Python interface to reading and writing Gwyddion files.
* [magni](https://github.com/SIP-AAU/Magni) compressive sampling and reconstruction of Atomic Force Microscopy images.
* [nanite](https://github.com/AFM-Analysis/nanite) loading, fitting and rating AFM force-distance data.
* [nanoforce](https://github.com/crj341/nanoforce) import and analyse AFM force curves produced using Nanoscope 5 & 6
  and Nanosurf `.nid` files.
* [nanoscope](https://github.com/jmarini/nanoscope) read data files collected using Bruker, Veeco, and Digital
  Instruments Atomic Force Microscopes (AFMs) using Nanoscope v5.12 - v10.00 acquisition software
* [NSFOpen](https://pypi.org/project/NSFopen/) Read data and parameters from Nanosurf NID files.
* [pycroscopy](https://pycroscopy.github.io/pycroscopy/about.html) Python Package for scientific analysis of nanoscience
  data.
* [pySPM](https://github.com/scholi/pySPM) read, handle and plot Scanning Probme Microscopy (SPM) images and ToF-SIMS data.

## C++

* [libasd](https://github.com/ToruNiina/libasd) library for reading asd files, includes Python 3 bindings.

## Other

* [gwyddion](http://gwyddion.net) a modular program for Scanning Probe Microscopy (SPM) data visualisation and analysis.
